/***************************************************************************
                          codegeneratorpointers.cpp  -  description
                             -------------------
    begin                : Fri May 12 2000
    copyright            : (C) 2000 by Ivan Martinez
    email                : ivan_m_r@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "codegeneratorpointers.h"

#include "codegenerator.h"

CCodeGeneratorPointers::CCodeGeneratorPointers()
{
}

CCodeGeneratorPointers::~CCodeGeneratorPointers()
{
}
/**  */
void CCodeGeneratorPointers::AllErrorsReport(CErrors& Errors) const
{
	CCodeGeneratorPointers::ConstIterator ComponentI;

  for (ComponentI = Begin(); ComponentI != End(); ComponentI++)
		(*ComponentI)->AllErrorsReport(Errors);
}
/**  */
void CCodeGeneratorPointers::DeleteObjects()
{
	CCodeGeneratorPointers::Iterator ComponentI;

  for (ComponentI = Begin(); ComponentI != End(); ComponentI++)
	{
		(*ComponentI)->DeleteObjects();
		delete *ComponentI;
	}
}
/**  */
void CCodeGeneratorPointers::GenerateCode(ostream& StreamL,
	const CCodeGenerator* CallerPL, const string& SectionL,
	void* ExtraParameterL = NULL) const
{
	CCodeGeneratorPointers::ConstIterator ComponentI;

  for (ComponentI = Begin(); ComponentI != End(); ComponentI++)
		(*ComponentI)->AllGenerateCode(StreamL, CallerPL, SectionL, ExtraParameterL);
}
/**  */
void CCodeGeneratorPointers::GenerateCode(CStringsSet& StringsSetL,
	const CCodeGenerator* CallerPL,	const string& SectionL,
	void* ExtraParameterL = NULL) const
{
	CCodeGeneratorPointers::ConstIterator ComponentI;

  for (ComponentI = Begin(); ComponentI != End(); ComponentI++)
		(*ComponentI)->AllGenerateCode(StringsSetL, CallerPL, SectionL, ExtraParameterL);
}
/**  */
void CCodeGeneratorPointers::ClearAllErrors()
{
	CCodeGeneratorPointers::Iterator ComponentI;

	for (ComponentI = Begin(); ComponentI != End(); ComponentI++)
		(*ComponentI)->AllClearErrors();
}
/**  */
bool CCodeGeneratorPointers::RepeatedValue(const CCodeGenerator* CallerPL,
	const string& ValueNameL, const string& ValueL) const
{
	CCodeGeneratorPointers::ConstIterator ComponentI;

	ComponentI = Begin();
	while ((ComponentI != End()) &&
			!(*ComponentI)->RepeatedValue(CallerPL, ValueNameL, ValueL))
		ComponentI++;
	return ComponentI != End();	
}
/**  */
bool CCodeGeneratorPointers::Arrange(void* ExtraParameterL = NULL)
{
	CCodeGeneratorPointers::Iterator ComponentI;

	ComponentI = Begin();
	while ((ComponentI != End()) && (*ComponentI)->AllArrange(ExtraParameterL))
		ComponentI++;
	return ComponentI == End();	
}
/**  */
unsigned int CCodeGeneratorPointers::DescendantsOf(const string& ClassName) const
{
	CCodeGeneratorPointers::ConstIterator ComponentI;
	unsigned int uNumber;

	uNumber = 0;
	for (ComponentI = Begin(); ComponentI != End(); ComponentI++)
		if ((*ComponentI)->DescendantOf(ClassName))
			uNumber++;

	return uNumber;
}
/**  */
bool CCodeGeneratorPointers::Contains(const CCodeGenerator* pComponent) const
{
	CCodeGeneratorPointers::ConstIterator ComponentI;

	ComponentI = Begin();
	while ((ComponentI != End()) && ((*ComponentI) != pComponent))
		ComponentI++;
	return ComponentI != End();	
}
