/***************************************************************************
                          codegeneratorpointers.h  -  description
                             -------------------
    begin                : Fri May 12 2000
    copyright            : (C) 2000 by Ivan Martinez
    email                : ivan_m_r@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CODEGENERATORPOINTERS_H
#define CODEGENERATORPOINTERS_H

/**
  *@author Ivan Martinez
  */

#include "derivablevector.h"

#include <string>
#include <set>
#include "errors.h"

class CCodeGenerator;

class CCodeGeneratorPointers : public TDerivableVector<CCodeGenerator*> {
public:
  /**  */
  typedef set<string,less<string> > CStringsSet;
  /**  */
  typedef vector<CCodeGenerator*>::const_iterator ConstIterator;
	/**  */
	CCodeGeneratorPointers();
  /**  */
	virtual ~CCodeGeneratorPointers();
  /**  */
  void AllErrorsReport(CErrors&) const;
  /**  */
  bool Arrange(void* ExtraParameterL = NULL);
  /**  */
	void ClearAllErrors();
  /**  */
  bool Contains(const CCodeGenerator*) const;
  /**  */
  virtual void DeleteObjects();
  /**  */
  virtual unsigned int DescendantsOf(const string&) const;
  /**  */
  virtual void GenerateCode(ostream&, const CCodeGenerator*, const string&,
		void* = NULL) const;
  /**  */
  virtual void GenerateCode(CStringsSet&, const CCodeGenerator*,
		const string&, void* = NULL) const;
  /**  */
  virtual bool RepeatedValue(const CCodeGenerator*, const string&, const string&) const;
};

#endif
