/***************************************************************************
                          commandingfifo.h  -  description
                             -------------------
    begin                : Thu Jun 1 2000
    copyright            : (C) 2000 by Ivan Martinez
    email                : ivan_m_r@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef COMMANDINGFIFO_H
#define COMMANDINGFIFO_H

#include "rtfifo.h"

/**
  *@author Ivan Martinez
  */

class CDynamicSystem;

class CCommandingFifo : public CRTFifo {
public:
	CCommandingFifo();
	~CCommandingFifo();
  /**  */
  virtual bool AcceptsContainer(const CCodeGenerator*);
  /**  */
  virtual string Class() const;
  /**  */
	const CDynamicSystem* Container() const;
  /**  */
  virtual bool DescendantOf(const string&) const;
  /**  */
  virtual unsigned int MaximumInComponents() const;
  /**  */
  unsigned int Number() const;
  /**  */
  bool SetNumber(unsigned int);
  /**  */
  bool SetSize(int);
  /**  */
  int Size() const;
protected:
  /**  */
  virtual void Arrange(void* = NULL);
  /**  */
  virtual void GenerateBeforeTasksWakeUp(ostream&, void* = NULL) const;
  /**  */
  virtual void GenerateCode(ostream&, const CCodeGenerator*, const string&,
		void* = NULL) const;
  /**  */
  virtual void GenerateCode(CStringsSet&, const CCodeGenerator*, const string&,
		void* = NULL) const;
  /**  */
  virtual void GenerateDestruction(ostream&, void* = NULL) const;
  /**  */
  virtual void GenerateFunctions(ostream&, void* = NULL) const;
  /**  */
  virtual void GenerateIncludes(CStringsSet&, void* = NULL) const;
  /**  */
  virtual void GenerateInitialization(ostream&, void* = NULL) const;
};

#endif
