/***************************************************************************
                          derivablevector.cpp  -  description
                             -------------------
    begin                : Fri May 12 2000
    copyright            : (C) 2000 by Ivan Martinez
    email                : ivan_m_r@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DERIVABLEVECTOR_CPP
#define DERIVABLEVECTOR_CPP

#include "derivablevector.h"

template <class Type>
TDerivableVector<Type>::TDerivableVector()
{
	m_Vector.clear();
}

template <class Type>
TDerivableVector<Type>::~TDerivableVector()
{
}
/**  */
template <class Type>
TDerivableVector<Type>::Iterator TDerivableVector<Type>::Begin()
{
	return m_Vector.begin();
}
/**  */
template <class Type>
TDerivableVector<Type>::ConstIterator TDerivableVector<Type>::Begin() const
{
	return m_Vector.begin();
}
/**  */
template <class Type>
TDerivableVector<Type>::Iterator TDerivableVector<Type>::End()
{
	return m_Vector.end();
}
/**  */
template <class Type>
TDerivableVector<Type>::ConstIterator TDerivableVector<Type>::End() const
{
	return m_Vector.end();
}
/**  */
template <class Type>
void TDerivableVector<Type>::Clear()
{
	m_Vector.clear();
}
/**  */
template <class Type>
void TDerivableVector<Type>::PushBack(Type Element)
{
	m_Vector.push_back(Element);
}
/**  */
template <class Type>
bool TDerivableVector<Type>::Empty() const
{
	return m_Vector.empty();
}
/**  */
template <class Type>
void TDerivableVector<Type>::Append(const TDerivableVector<Type>& Vector)
{
	m_Vector.insert(End(), Vector.Begin(), Vector.End());
}
/**  */
template <class Type>
unsigned int TDerivableVector<Type>::Size() const
{
	return m_Vector.size();
}
/**  */
template <class Type>
Type TDerivableVector<Type>::operator[](unsigned int Position) const
{
	return m_Vector[Position];
}

/**  */
template <class Type>
Type TDerivableVector<Type>::operator[](unsigned int Position)
{
	return m_Vector[Position];
}

#endif