/***************************************************************************
                          error.cpp  -  description
                             -------------------
    begin                : Mon Jul 17 2000
    copyright            : (C) 2000 by Ivan Martinez
    email                : ivan_m_r@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "error.h"

CError::CError(){
}
CError::~CError(){
}
/**  */
void CError::SetLocation(const CCodeGenerator* Location)
{
	m_pLocation = Location;
}
/**  */
const CCodeGenerator* CError::Location() const
{
	return m_pLocation;
}
/**  */
void CError::SetNumber(unsigned int uNumber)
{
	m_uNumber = uNumber;
}
/**  */
unsigned int CError::Number() const
{
	return m_uNumber;
}
/**  */
const string CError::Message() const
{
	switch (Number())
	{
		/* 1XX: Error in CCodeGenerator's members */
		case 100:
			return "Identifier is not a valid C identifier";
		case 101:
			return "Class is not a suitable container for this component";
		case 102:
			return "Couldn't add component";
		/* 2XX: Errors in CRTModule's members */
		/* 3XX: Errors in CRTTask's members */
		case 300:
			return "Period must be greater than 0";
		/* 4XX: Errors in CRTFifo's members */
		case 400:
			return "Fifo's number must be greater or equal than 0";
		case 401:
			return "Fifo's size must be greater than 0";
		/* 5XX: Errors in CBlock' members */
		case 500:
			return "Block's name is not a valid C identifier";
		case 501:
			return "Name repeated in the loop";
		case 502:
			return "Block couldn't be ordered";
		/* 6XX: Errors in CVariable's members */
		case 600:
			return "Variable's name is not a valid C identifier";
		case 601:
			return "Name repeated in the scope";
		case 602:
			return "Variable's type is not a valid C identifier";
		/* 7XX: Errors in CInitializableVariable's members */
		/* 8XX: Errors in CVariableFifo's members */
		/* 9XX: Errors in CDynamicSystem's members */
		case 900:
			return "Dynamic sytem's time must be greater than 0";
		/* 10XX: Errors in CLoop's members */
		case 1000:
			return "Name repeated in the scope";
		/* 11XX: Errors in CFunction's members */
		/* 12XX: Errors in CSystemVariable's members*/
		/* 13XX: Errors in CLoopVariable's members */
		/* 14XX: Errors in CInputVariable's members */
		case 1400:
			return "Input variable not linked";
		case 1401:
			return "Redundant initialization in input variable";
		/* 15XX: Errors in COutputVariable's members */
		/* 16XX: Errors in CBlockVariable's members */
		/* 17XX: Errors in CCommandingFifo' members */
		case 1700:
			return "There can't be more than one commanding fifo in the system";
		/* 18XX: Errors in CReportingFifo's members */
		case 1800:
			return "There can't be more than one reporting fifo in the loop";
		/* 19XX: Errors in CLoggingFifo's members */
		case 1900:
			return "There can't be more than one logging fifo in the variable";
		/* 20XX: Errors in CSettingFifo's members */
		case 2000:
			return "There can't be more than one setting fifo in the variable";
		default:
			return "Unknown error";
	}
}
