/***************************************************************************
                          functionoutput.cpp  -  description
                             -------------------
    begin                : Mon Mar 27 2000
    copyright            : (C) 2000 by 
    email                : ivan_m_r@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "functionoutput.h"

#include "function.h"
#include "loop.h"

CFunctionOutput::CFunctionOutput()
{
}
CFunctionOutput::~CFunctionOutput()
{
}
/**  */
string CFunctionOutput::Class() const
{
	return "CFunctionOutput";
}
/**  */
bool CFunctionOutput::SetName(const string& NameL)
{
	SetLocalIdentifier(NameL);

	if (IllegalCIdentifier(NameL))
	{
		AddError(600);
		return false;
	}	
	else
	{
		return true;
	}
}
/**  */
void CFunctionOutput::Arrange(void *ExtraParameterL = NULL)
{
	if (IllegalCIdentifier(LocalIdentifier()))
		AddError(600);
	else
	{
		SetIdentifier("iovar_" + Container()->Container()->Identifier() + "_" +
			Container()->Name() + "_" + LocalIdentifier());
	}
}
/**  */
bool CFunctionOutput::DescendantOf(const string& ClassNameL) const
{
	if (ClassNameL == "CFunctionOutput")
		return true;
	else
		return COutput::DescendantOf(ClassNameL);
}
/**  */
void CFunctionOutput::GenerateCode(ostream& StreamL, const CCodeGenerator* CallerPL,
	const string& SectionL, void* ExtraParameterL = NULL) const
{
	if (CallerPL->DescendantOf("CDynamicSystem"))
	{
		if (SectionL == "global variables declaration")
			GenerateGlobalDeclarations(StreamL, ExtraParameterL);
	}
	else
		if (CallerPL->DescendantOf("CFunction"))
			if (SectionL == "local declarations")
				GenerateLocalDeclarations(StreamL, ExtraParameterL);
			else			
				if (SectionL == "outputs writing")
					GenerateGlobalWriting(StreamL, ExtraParameterL);
}
/**  */
//Del by KDevelop: bool CFunctionOutput::SetCalculated(bool CalculatedL)
//Del by KDevelop: {
//Del by KDevelop: 	CalculatedA = CalculatedL;
//Del by KDevelop:
//Del by KDevelop: 	return true;
//Del by KDevelop: }
/**  */
//Del by KDevelop: bool CFunctionOutput::Calculated() const
//Del by KDevelop: {
//Del by KDevelop: 	return CalculatedA;
//Del by KDevelop: }
/**  */
const CFunction* CFunctionOutput::Container() const
{
	return (CFunction*)CCodeGenerator::Container();
}
/**  */
bool CFunctionOutput::SetType(const string& Type)
{
	CVariable::SetType(Type);

	if (IllegalCIdentifier(Type))
	{
		AddError(602);
		return false;
	}	
	else
		return true;
}
/**  */
bool CFunctionOutput::AcceptsContainer(const CCodeGenerator* pContainer)
{
	if (pContainer->DescendantOf("CFunction"))
	{
		SetContainer(pContainer);
		return true;
	}
	else
	{
		AddError(101);
		return false;
	}
}
/**  */
//Del by KDevelop: void CFunctionOutput::ComponentsDependingArrange(void* pExtraParameter = NULL)
//Del by KDevelop: {
//Del by KDevelop: 	if (Container()->RepeatedValue(this, "name", LocalIdentifier()))
//Del by KDevelop: 		AddError(601);
//Del by KDevelop: }
