/***************************************************************************
                          inputvariable.cpp  -  description
                             -------------------
    begin                : Mon Mar 27 2000
    copyright            : (C) 2000 by Ivan Martinez
    email                : ivan_m_r@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "input.h"

#include "block.h"
#include "loop.h"

CInput::CInput()
{
	m_pConnectedOutput = NULL;
}
CInput::~CInput()
{
}
/**  */
const COutput* CInput::ConnectedOutput() const
{
	return m_pConnectedOutput;
}
/**  */
bool CInput::Connect(COutput* pOutput)
{
	m_pConnectedOutput = pOutput;

	return true;
}
/**  */
//Del by KDevelop: string CInput::Class() const
//Del by KDevelop: {
//Del by KDevelop: 	return "CInput";
//Del by KDevelop: }
/**  */
//Del by KDevelop: bool CInput::SetName(const string& NameL)
//Del by KDevelop: {
//Del by KDevelop: 	SetLocalIdentifier(NameL);
//Del by KDevelop: 
//Del by KDevelop: 	if (IllegalCIdentifier(NameL))
//Del by KDevelop: 	{
//Del by KDevelop: 		AddError(600);
//Del by KDevelop: 		return false;
//Del by KDevelop: 	}	
//Del by KDevelop: 	else
//Del by KDevelop: 	{
//Del by KDevelop: 		return true;
//Del by KDevelop: 	}
//Del by KDevelop: }
/**  */
bool CInput::DescendantOf(const string& ClassNameL) const
{
	if (ClassNameL == "CInput")
		return true;
	else
		return CVariable::DescendantOf(ClassNameL);
}
/**  */
void CInput::Arrange(void* ExtraParameterL = NULL)
{
	if (IllegalCIdentifier(LocalIdentifier()))
		AddError(600);
	else
		if (Connected())
			SetIdentifier("iovar_" + Container()->Container()->Identifier() + "_" +
				ConnectedOutput()->Container()->Name() + "_" +
				ConnectedOutput()->LocalIdentifier());
		else
			AddError(1400);
}
/**  */
//Del by KDevelop: void CInput::GenerateCode(ostream& StreamL, const CCodeGenerator* CallerPL,
//Del by KDevelop: 	const string& SectionL, void* ExtraParameterL = NULL) const
//Del by KDevelop: {
//Del by KDevelop: 	if (CallerPL->DescendantOf("CBlock"))
//Del by KDevelop: 	{
//Del by KDevelop: 		if (SectionL == "initialized variables declaration")
//Del by KDevelop: 			GenerateInitializationDeclaration(StreamL, ExtraParameterL);
//Del by KDevelop: 		else
//Del by KDevelop: 			if (SectionL == "variables initialization")
//Del by KDevelop: 				GenerateInitialization(StreamL, ExtraParameterL);
//Del by KDevelop: 			else
//Del by KDevelop: 				if (SectionL == "initialized variables writing")
//Del by KDevelop: 					GenerateInitializationWriting(StreamL, ExtraParameterL);
//Del by KDevelop: 				else
//Del by KDevelop: 					if (SectionL == "local declarations")
//Del by KDevelop: 						GenerateLocalDeclarations(StreamL, ExtraParameterL);
//Del by KDevelop: 					else			
//Del by KDevelop: 						if (SectionL == "inputs reading")
//Del by KDevelop: 							GenerateGlobalReading(StreamL, ExtraParameterL);
//Del by KDevelop: 	}
//Del by KDevelop: }
/**  */
//Del by KDevelop: bool CInput::Calculated() const
//Del by KDevelop: {
//Del by KDevelop: 	if (Connected())
//Del by KDevelop: 		return ConnectedOutput()->Calculated();
//Del by KDevelop: 	else
//Del by KDevelop: 		return false;
//Del by KDevelop: }
/**  */
const CBlock* CInput::Container() const
{
	return (CBlock*)CInitializableVariable::Container();
}
/**  */
bool CInput::Connected() const
{
	return (ConnectedOutput() != NULL);
}
/**  */
bool CInput::ConnectedToOrderedBlock(const CCodeGeneratorPointers& OrderedComponents) const
{
	if (Connected())
		return OrderedComponents.Contains(ConnectedOutput()->Container());
	else
		return false;
}
/**  */
bool CInput::SetInitialization(const string& Initialization)
{
	CInitializableVariable::SetInitialization(Initialization);

	return true;
}
