/***************************************************************************
                          input.h  -  description
                             -------------------
    begin                : Mon Mar 27 2000
    copyright            : (C) 2000 by Ivan Martinez
    email                : ivan_m_r@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INPUT_H
#define INPUT_H

#include "initializablevariable.h"

/**
  *@author Ivan Martinez
  */

#include "loggingfifo.h"
#include "output.h"

class CBlock;

class CInput : public CInitializableVariable {
public:
	CInput();
	~CInput();
  /**  */
  bool Connect(COutput*);
  /**  */
  bool Connected() const;
  /**  */
  const COutput* ConnectedOutput() const;
  /**  */
  bool ConnectedToOrderedBlock(const CCodeGeneratorPointers&) const;
  /**  */
  const CBlock* Container() const;
  /**  */
  virtual bool DescendantOf(const string&) const;
  /**  */
  bool SetInitialization(const string&);
  /**  */
protected:
  /**  */
	virtual void Arrange(void* = NULL);
  /**  */
private: // Private attributes
  /**  */
  const COutput* m_pConnectedOutput;
};

#endif
