/***************************************************************************
                          reportingfifo.h  -  description
                             -------------------
    begin                : Thu Jun 1 2000
    copyright            : (C) 2000 by Ivan Martinez
    email                : ivan_m_r@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef REPORTINGFIFO_H
#define REPORTINGFIFO_H

#include "rtfifo.h"

/**
  *@author Ivan Martinez
  */

class CLoop;

class CReportingFifo : public CRTFifo  {
public:
	CReportingFifo();
	~CReportingFifo();
  /**  */
  virtual bool AcceptsContainer(const CCodeGenerator*);
  /**  */
  virtual void Arrange(void* = NULL);
  /**  */
  virtual string Class() const;
  /**  */
  const CLoop* Container() const;
  /**  */
  virtual bool DescendantOf(const string&) const;
  /**  */
  virtual unsigned int MaximumInComponents() const;
  /**  */
  unsigned int Number() const;
  /**  */
  bool SetNumber(unsigned int);
  /**  */
  bool SetSize(int);
  /**  */
  int Size();
protected:
  /**  */
  virtual void GenerateCode(ostream&, const CCodeGenerator*, const string&,
		void* = NULL) const;
  /**  */
  virtual void GenerateCode(CStringsSet&, const CCodeGenerator*,
		const string&, void* = NULL) const;
  /**  */
  virtual void GenerateEndTimeLog(ostream&, void* = NULL) const;
  /**  */
  virtual void GenerateIncludes(CStringsSet&, void* = NULL) const;
  /**  */
  virtual void GenerateStartTimeLog(ostream&, void* = NULL) const;
  /**  */
  virtual void GenerateStaticDeclarations(CStringsSet&, void* = NULL) const;
};

#endif