/***************************************************************************
                          rtfifo.h  -  description
                             -------------------
    begin                : Tue May 23 2000
    copyright            : (C) 2000 by Ivan Martinez
    email                : ivan_m_r@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef RTFIFO_H
#define RTFIFO_H

#include "codegenerator.h"

/**
  *@author Ivan Martinez
  */

class CRTFifo : public CCodeGenerator  {
public:
	enum EMode {READ, WRITE};
  /**  */
	CRTFifo();
  /**  */
	virtual ~CRTFifo();
  /**  */
  const string& Buffer() const;
  /**  */
  const string& BufferSize() const;
  /**  */

  /**  */
  virtual bool DescendantOf(const string&) const;
  /**  */
  EMode Mode() const;
  /**  */
  const string& Number() const;
  /**  */
  const string& Size() const;
protected:
  /**  */
  virtual void GenerateDeclaration(ostream&, void* = NULL) const;
  /**  */
  virtual void GenerateDestruction(ostream&, void* = NULL) const;
  /**  */
  virtual void GenerateFifoReading(ostream&, void* = NULL) const;
  /**  */
  virtual void GenerateFifoWriting(ostream&, void* = NULL) const;
  /**  */
  virtual void GenerateIncludes(CStringsSet&, void* = NULL) const;
  /**  */
  virtual void GenerateInitialization(ostream&, void* = NULL) const;
  /**  */
  void SetBuffer(const string&);
  /**  */
  void SetBufferSize(const string&);
  /**  */
  void SetMode(EMode);
  /**  */
  void SetNumber(const string&);
  /**  */
  void SetSize(const string&);
private: // Private attributes
  /**  */
  string m_Size;
  /**  */
  string m_Number;
  /**  */
  EMode m_Mode;
  /**  */
  string BufferA;
  /**  */
  string BufferSizeA;
};

#endif
