/***************************************************************************
                          settingfifo.h  -  description
                             -------------------
    begin                : Thu Jun 1 2000
    copyright            : (C) 2000 by Ivan Martinez
    email                : ivan_m_r@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SETTINGFIFO_H
#define SETTINGFIFO_H

#include "variablefifo.h"

/**
  *@author Ivan Martinez
  */

class CInitializableVariable;

class CSettingFifo : public CVariableFifo  {
public:
	CSettingFifo();
	~CSettingFifo();
  /**  */
  virtual string Class() const;
  /**  */
  const CInitializableVariable* Container() const;
  /**  */

  /**  */
  virtual bool DescendantOf(const string&) const;
  /**  */
  virtual string IncompatibleClass() const;
  /**  */
  virtual unsigned int MaximumInComponents() const;
  /**  */
  unsigned int Number() const;
  /**  */
  bool SetNumber(unsigned int);
  /**  */
  bool SetSize(int);
  /**  */
  int Size();
  /**  */
  virtual bool AcceptsContainer(const CCodeGenerator*);
protected:
  /**  */
  virtual void Arrange(void* = NULL);
  /**  */
  virtual void GenerateCode(ostream&, const CCodeGenerator*, const string&, void* = NULL) const;
  /**  */
  virtual void GenerateLockedFifoReading(ostream&, void* = NULL) const;
};

#endif
