/***************************************************************************
                          systemvariable.h  -  description
                             -------------------
    begin                : Tue Apr 18 2000
    copyright            : (C) 2000 by 
    email                : ivan_m_r@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SYSTEMVARIABLEC_H
#define SYSTEMVARIABLEC_H

#include "initializablevariable.h"

/**
  *@author Ivan Martinez
  */

#include "loggingfifo.h"
#include "settingfifo.h"
#include <iostream>

class CDynamicSystem;

class CSystemVariable : public CInitializableVariable {
public:
	CSystemVariable();
	~CSystemVariable();
  /**  */
  virtual bool AcceptsContainer(const CCodeGenerator*);
  /**  */
  virtual string Class() const;
  /**  */
  const CDynamicSystem* Container() const;
  /**  */
  virtual bool DescendantOf(const string&) const;
  /**  */
  const string& LockIdentifier() const;
  /**  */
  bool SetInitialization(const string&);
  /**  */
  bool SetName(const string&);
  /**  */
  bool SetType(const string&);
protected:
  /**  */
  virtual void GenerateCode(ostream&, const CCodeGenerator*, const string&,
		void* = NULL) const;
  /**  */
  virtual void GenerateCode(CStringsSet&, const CCodeGenerator*, const string&,
		void* = NULL) const;
  /**  */
  virtual void GenerateGlobalDeclarations(ostream&, void* = NULL) const;
  /**  */
  virtual void GenerateGlobalReading(ostream&, void* = NULL) const;
  /**  */
  virtual void GenerateGlobalWriting(ostream&, void* = NULL) const;
  /**  */
  virtual void GenerateIncludes(CStringsSet&, void* = NULL) const;
  /**  */
	virtual void GenerateLocalDeclarations(CStringsSet&, void* = NULL) const;
  /**  */
  virtual void GenerateLocalDeclarations(ostream&, void* = NULL) const;
  /**  */
  void SetLockIdentifier(const string&);
private: // Private attributes
  /**  */
  string LockIdentifierA;
};

#endif
