/***************************************************************************
                          variable.cpp  -  description
                             -------------------
    begin                : Fri Feb 11 2000
    copyright            : (C) 2000 by Ivan Martinez
    email                : ivan_m_r@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "variable.h"

CVariable::CVariable()
{
	LocalIdentifierA = "";
	TypeA = "";
}
CVariable::~CVariable()
{
}
/**  */
const string& CVariable::LocalIdentifier() const
{
	return LocalIdentifierA;	
}
/**  */
const string& CVariable::Type() const
{
	return TypeA;
}
/**  */
void CVariable::SetType(const string& Type)
{
	TypeA = Type;
}
/**  */
void CVariable::GenerateGlobalDeclarations(ostream& StreamL,
	void* ExtraParameterL = NULL) const
{
	StreamL << TypeA << " " << Identifier() << ";" << endl;
}
/**  */
//Del by KDevelop: const CCodeGeneratorPV& CVariable::Components() const
//Del by KDevelop: {
//Del by KDevelop: 	return CCodeGenerator::Components();
//Del by KDevelop: }
/**  */
void CVariable::SetLocalIdentifier(const string& Identifier)
{
	LocalIdentifierA = Identifier;

/*
	if (IllegalCIdentifier(IdentifierL))
	{
		ErrorsReport().insert("\"" + IdentifierL + "\" is not a valid C identifier");
		return false;
	}	
	else
	{
		LocalIdentifierA = IdentifierL;
		return true;
	}
*/
}
/**  */
bool CVariable::DescendantOf(const string& ClassNameL) const
{
	if (ClassNameL == "CVariable")
		return true;
	else
		return CCodeGenerator::DescendantOf(ClassNameL);
}
/**  */
void CVariable::GenerateLocalDeclarations(ostream& StreamL,
	void* ExtraParameterL = NULL) const
{
	StreamL	<< "  static " << Type() << " " << LocalIdentifier() << ";" << endl;
}
/**  */
void CVariable::GenerateGlobalReading(ostream& StreamL, void* ExtraParameterL = NULL) const
{
	StreamL << "  " << LocalIdentifier() << " = " << Identifier() << ";" << endl;
}
/**  */
void CVariable::GenerateGlobalWriting(ostream& StreamL, void* ExtraParameterL = NULL) const
{
	StreamL << "  " << Identifier() << " = " << LocalIdentifier() << ";" << endl;
}
/**  */
void CVariable::ComponentsDependingArrange(void* ExtraParameterL = NULL)
{
	if (Container()->RepeatedValue(this, "name", LocalIdentifier()))
		AddError(601);
}
/**  */
bool CVariable::RepeatedValue(const CCodeGenerator* CallerPL, const string& ValueNameL,
	const string& ValueL) const
{
	if ((CallerPL != this) && (ValueNameL == "name") &&
			(ValueL == LocalIdentifier()))
		return true;
	else
		return Components().RepeatedValue(CallerPL, ValueNameL, ValueL);
}
