/***************************************************************************
                          variable.h  -  description
                             -------------------
    begin                : Fri Feb 11 2000
    copyright            : (C) 2000 by Ivan Martinez
    email                : ivan_m_r@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef VARIABLE_H
#define VARIABLE_H

#include "codegenerator.h"

/**
  *@author Ivan Martinez
  */

class CVariable : public CCodeGenerator {
public:
	CVariable();
	~CVariable();
  /**  */
  virtual bool DescendantOf(const string&) const;
  /**  */
  const string& LocalIdentifier() const;
  /**  */
  const string& Type() const;
protected:
  /**  */
  virtual void ComponentsDependingArrange(void* = NULL);
  /**  */
  virtual void GenerateGlobalDeclarations(ostream&, void* = NULL) const;
  /**  */
  virtual void GenerateGlobalReading(ostream&, void* = NULL) const;
  /**  */
  virtual void GenerateGlobalWriting(ostream&, void* = NULL) const;
  /**  */
  virtual void GenerateLocalDeclarations(ostream&, void* = NULL) const;
  /**  */
  virtual bool RepeatedValue(const CCodeGenerator*, const string&, const string&) const;
  /**  */
  void SetLocalIdentifier(const string&);
  /**  */
  void SetType(const string&);
private: // Private attributes
  /**  */
  string LocalIdentifierA;
  /**  */
  string TypeA;
};

#endif
